## dublin-traceroute 0.3

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
project (dublin-traceroute)

set (dublin-traceroute_VERSION_MAJOR_0)
set (dublin-traceroute_VERSION_MINOR_2)

# ensure that /usr/local is used to find dependencies. This is especially
# necessary for brew on OSX and for libraries installed manually under
# /usr/local
list(APPEND CMAKE_PREFIX_PATH /usr/local)

include_directories("${PROJECT_SOURCE_DIR}/include")

add_library(dublintraceroute SHARED
    src/common.cc
    src/dublin_traceroute.cc
    src/hop.cc
    src/traceroute_results.cc
)

# Set the shared library version
set_target_properties(dublintraceroute
    PROPERTIES
      SOVERSION 0.0.0
    )

find_package(PkgConfig)
find_package(Threads REQUIRED)
find_package(libtins 3.4)
if (${libtins_FOUND})
    MESSAGE(STATUS "libtins found via CMake")
else (${libtins_FOUND})
    MESSAGE(STATUS "libtins not found via CMake, trying pkg-config")
    pkg_search_module(libtins REQUIRED libtins)
endif (${libtins_FOUND})

pkg_search_module(JSONCPP REQUIRED jsoncpp)

add_executable(dublin-traceroute src/main.cc)
target_link_libraries(dublintraceroute ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(dublin-traceroute dublintraceroute)
target_link_libraries(dublintraceroute tins)

target_link_libraries(dublintraceroute ${JSONCPP_LIBRARIES} jsoncpp)
target_include_directories(dublintraceroute PUBLIC ${JSONCPP_INCLUDE_DIRS})

#set_property(TARGET dublintraceroute PROPERTY CXX_STANDARD 11)
#set_property(TARGET dublintraceroute PROPERTY CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

add_dependencies(dublin-traceroute dublintraceroute)

install(TARGETS dublin-traceroute dublintraceroute
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    )
install(DIRECTORY include/dublintraceroute DESTINATION include)

=== debian/changelog ===
dublin-traceroute (0.3-3) unstable; urgency=medium

  * Add dependencies on libdulintraceroute0 (Closes: #857162)

 -- Federico Ceratto <federico@debian.org>  Fri, 17 Mar 2017 10:34:42 +0000

dublin-traceroute (0.3-2) unstable; urgency=medium

  * Releasing v. 0.3-2 to Unstable

 -- Federico Ceratto <federico@debian.org>  Sat, 09 Jul 2016 12:04:42 +0100

dublin-traceroute (0.3-1) experimental; urgency=medium

  * Initial release (Closes: #818284)

 -- Federico Ceratto <federico@debian.org>  Sun, 26 Jun 2016 12:46:13 +0100

=== debian/control ===
Source: dublin-traceroute
Section: net
Priority: optional
Maintainer: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>=9),
 cmake,
 libpcap-dev,
 libtins3.4 (>=3.4-2),
 libtins-dev (>=3.4-2),
 pkg-config,
 libjsoncpp-dev
Standards-Version: 3.9.8
Homepage: https://dublin-traceroute.net
Vcs-Git: https://anonscm.debian.org/collab-maint/dublin-traceroute.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/dublin-traceroute.git

Package: dublin-traceroute
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdublintraceroute0 (= ${binary:Version})
Description: NAT-aware multipath tracerouting tool
 Dublin Traceroute uses the techniques invented by the authors of
 Paris-traceroute to enumerate the paths of ECMP flow-based load balancing,
 but also introduces a new technique for NAT detection. It forges the IP ID
 in the probe packet and analyzes the responses in order to detect all the
 encountered NATs.

Package: libdublintraceroute0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NAT-aware multipath tracerouting tool (library)
 Dublin Traceroute uses the techniques invented by the authors of
 Paris-traceroute to enumerate the paths of ECMP flow-based load balancing,
 but also introduces a new technique for NAT detection. It forges the IP ID
 in the probe packet and analyzes the responses in order to detect all the
 encountered NATs.
 This package contains a dynamic library.

Package: libdublintraceroute-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdublintraceroute0 (= ${binary:Version})
Description: NAT-aware multipath tracerouting tool (dev)
 Dublin Traceroute uses the techniques invented by the authors of
 Paris-traceroute to enumerate the paths of ECMP flow-based load balancing,
 but also introduces a new technique for NAT detection. It forges the IP ID
 in the probe packet and analyzes the responses in order to detect all the
 encountered NATs.
 This package contains development files.

## dublin-traceroute 0.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,27 +1,32 @@
 cmake_minimum_required (VERSION 2.8)
 project (dublin-traceroute)
 
+# TODO sync this with VERSION in include/dublintraceroute/common.h
 set (dublin-traceroute_VERSION_MAJOR_0)
-set (dublin-traceroute_VERSION_MINOR_2)
+set (dublin-traceroute_VERSION_MINOR_4)
+set (dublin-traceroute_VERSION_PATCH_2)
 
 # ensure that /usr/local is used to find dependencies. This is especially
 # necessary for brew on OSX and for libraries installed manually under
 # /usr/local
 list(APPEND CMAKE_PREFIX_PATH /usr/local)
 
-include_directories("${PROJECT_SOURCE_DIR}/include")
+include_directories(
+    "${PROJECT_SOURCE_DIR}/include"
+)
 
 add_library(dublintraceroute SHARED
     src/common.cc
     src/dublin_traceroute.cc
     src/hop.cc
+    src/udpv4probe.cc
     src/traceroute_results.cc
 )
 
 # Set the shared library version
 set_target_properties(dublintraceroute
     PROPERTIES
-      SOVERSION 0.0.0
+      SOVERSION 0.1.1
     )
 
 find_package(PkgConfig)
@@ -50,8 +55,72 @@
 
 add_dependencies(dublin-traceroute dublintraceroute)
 
+if (NOT CMAKE_INSTALL_BINDIR)
+    set(CMAKE_INSTALL_BINDIR "bin")
+endif()
+
+if (NOT CMAKE_INSTALL_LIBDIR)
+    set(CMAKE_INSTALL_LIBDIR "lib")
+endif()
+
 install(TARGETS dublin-traceroute dublintraceroute
-    RUNTIME DESTINATION bin
-    LIBRARY DESTINATION lib
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     )
 install(DIRECTORY include/dublintraceroute DESTINATION include)
+
+# find setcap
+find_program(SETCAP_EXECUTABLE
+    NAMES
+        setcap
+    PATHS
+        /bin
+        /usr/bin
+        /usr/local/bin
+        /sbin
+)
+
+if (SETCAP_EXECUTABLE)
+    install(CODE "execute_process(
+        COMMAND
+            ${SETCAP_EXECUTABLE}
+            cap_net_raw+ep
+            ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/dublin-traceroute
+        RESULT_VARIABLE
+            SETCAP_RESULT
+        )
+        if (SETCAP_RESULT)
+            message(WARNING \"setcap failed (${SETCAP_RESULT})\")
+        endif()"
+    )
+endif()
+
+
+# Testing
+INCLUDE(ExternalProject)
+# Only include googletest if the git submodule has been fetched
+IF(EXISTS "${CMAKE_SOURCE_DIR}/googletest/CMakeLists.txt")
+    # Enable tests and add the test directory
+    MESSAGE(STATUS "Tests have been enabled")
+    SET(GOOGLETEST_ROOT ${CMAKE_SOURCE_DIR}/googletest)
+    SET(GOOGLETEST_INCLUDE ${GOOGLETEST_ROOT}/googletest/include)
+    SET(GOOGLETEST_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/googletest)
+    SET(GOOGLETEST_LIBRARY ${GOOGLETEST_BINARY_DIR}/googletest)
+
+    ExternalProject_Add(
+        googletest
+        DOWNLOAD_COMMAND ""
+        SOURCE_DIR ${GOOGLETEST_ROOT}
+        BINARY_DIR ${GOOGLETEST_BINARY_DIR}
+        CMAKE_CACHE_ARGS "-DBUILD_GTEST:bool=ON" "-DBUILD_GMOCK:bool=OFF"
+                         "-Dgtest_force_shared_crt:bool=ON"
+        INSTALL_COMMAND ""
+    )
+    # Make sure we build googletest before anything else
+    ADD_DEPENDENCIES(dublintraceroute googletest)
+    ENABLE_TESTING()
+    ADD_SUBDIRECTORY(tests)
+ELSE()
+    MESSAGE(STATUS "googletest git submodule is absent. Run `git submodule init && git submodule update` to get it")
+ENDIF()
+

=== tests/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${gtest_INCLUDE_DIRS})
ADD_SUBDIRECTORY(src)

=== tests/src/CMakeLists.txt ===
# This file is shamelessly copied and modified from libtins.
# Use dublintraceroute's include directories + test include directories
INCLUDE_DIRECTORIES(
    ${PROJECT_SOURCE_DIR}/include/dublintraceroute/
    ${GOOGLETEST_INCLUDE}
)

# Find pthread library
FIND_PACKAGE(Threads REQUIRED)

LINK_DIRECTORIES(
    ${GOOGLETEST_LIBRARY}
)
# Link against GoogleTest, libdublintraceroute and pthread.
# Pthread is required by GoogleTest
LINK_LIBRARIES(
    gtest
    gtest_main
    dublintraceroute
    ${CMAKE_THREAD_LIBS_INIT}
)

# Add tests target
ADD_CUSTOM_TARGET(
    tests DEPENDS
    UDPv4Test
    HopTest
    HopsTest
    ${OPTIONAL_TEST_TARGETS}
)

# Test executables

ADD_EXECUTABLE(UDPv4Test EXCLUDE_FROM_ALL udpv4.cxx)
ADD_EXECUTABLE(HopTest EXCLUDE_FROM_ALL hop.cxx)
ADD_EXECUTABLE(HopsTest EXCLUDE_FROM_ALL hops.cxx)

# Tests

ADD_TEST(UDPv4 UDPv4Test)
ADD_TEST(Hop HopTest)
ADD_TEST(Hops HopsTest)

=== debian/changelog ===
dublin-traceroute (0.4.2-3) unstable; urgency=medium

  * Update libtins version (Closes: #1069986)

 -- Federico Ceratto <federico@debian.org>  Sun, 28 Apr 2024 12:53:43 +0200

dublin-traceroute (0.4.2-2) unstable; urgency=medium

  * Update dependencies (Closes: #894345)

 -- Federico Ceratto <federico@debian.org>  Thu, 27 Sep 2018 00:49:40 +0100

dublin-traceroute (0.4.2-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sat, 28 Oct 2017 19:26:04 +0100

dublin-traceroute (0.4.0-2) experimental; urgency=medium

  * Set strict version on libdublintraceroute0 dependency

 -- Federico Ceratto <federico@debian.org>  Thu, 09 Feb 2017 20:26:43 +0000

dublin-traceroute (0.4.0-1) experimental; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Mon, 16 Jan 2017 22:04:47 +0000

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,23 @@
 Section: net
 Priority: optional
 Maintainer: Federico Ceratto <federico@debian.org>
-Build-Depends: debhelper (>=9),
+Build-Depends: debhelper-compat (= 13),
  cmake,
  libpcap-dev,
- libtins3.4 (>=3.4-2),
- libtins-dev (>=3.4-2),
+ libssl-dev,
+ libtins4.5 (>= 4.5),
+ libtins-dev (>= 4.5),
  pkg-config,
  libjsoncpp-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.2.1
 Homepage: https://dublin-traceroute.net
-Vcs-Git: https://anonscm.debian.org/collab-maint/dublin-traceroute.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/dublin-traceroute.git
+Vcs-Browser: https://salsa.debian.org/debian/dublin-traceroute
+Vcs-Git: https://salsa.debian.org/debian/dublin-traceroute.git
 
 Package: dublin-traceroute
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, libdublintraceroute0 (= ${binary:Version})
+Recommends: libcap2-bin
 Description: NAT-aware multipath tracerouting tool
  Dublin Traceroute uses the techniques invented by the authors of
  Paris-traceroute to enumerate the paths of ECMP flow-based load balancing,
@@ -26,6 +28,7 @@
 
 Package: libdublintraceroute0
 Architecture: any
+Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: NAT-aware multipath tracerouting tool (library)
  Dublin Traceroute uses the techniques invented by the authors of
@@ -37,7 +40,11 @@
 
 Package: libdublintraceroute-dev
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libdublintraceroute0 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends},
+ libdublintraceroute0 (= ${binary:Version}),
+ libjsoncpp-dev,
+ libtins-dev
+Section: libdevel
 Description: NAT-aware multipath tracerouting tool (dev)
  Dublin Traceroute uses the techniques invented by the authors of
  Paris-traceroute to enumerate the paths of ECMP flow-based load balancing,

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/obj-x86_64-linux-gnu --dpkg-shlibdeps-params=--ignore-missing-info
